/*******************************************************************
*
*  DESCRIPTION: Atomic Model PairedDeviceFinder
*
*  AUTHOR: Shafagh Jafer
*
*  EMAIL: sjafer@connect.carleton.ca
*
*
*  DATE: 8/06/2006
*
*******************************************************************/
#ifndef __PairedDeviceFinder_H
#define __PairedDeviceFinder_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class PairedDeviceFinder: public Atomic
{
public:
	PairedDeviceFinder( const string &name = "PairedDeviceFinder" ) ;	 // Default constructor

	

	virtual string className() const
		{return "PairedDeviceFinder";}

protected:
	Model &initFunction()
		{   receiverID = reqSearch = 0;
			
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &search;
    const Port &IDin ;
    Port &getID;
    Port &deviceID ;
    Time processingTime;
    int   receiverID, reqSearch;
	

    
};	// class PairedDeviceFinder


#endif    //__PairedDeviceFinder_H
