/*******************************************************************
*
*  DESCRIPTION: Atomic Model PermissionVerifier
*
*  AUTHOR: Shafagh Jafer
*
*  EMAIL: sjafer@connect.carleton.ca
*
*
*  DATE: 8/06/2006
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>
#include "PermissionVerifier.h"  // base header
#include "message.h"       // InternalMessage ....
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: PermissionVerifier
* Description: constructor
********************************************************************/
PermissionVerifier::PermissionVerifier( const string &name )
: Atomic( name )
, connectDevice( addInputPort( "connectDevice" ) )
, granted( addInputPort( "granted" ) )
, connected( addOutputPort( "connected" ) )
, reqPermission( addOutputPort( "reqPermission" ) )
, processingTime (0,0,2,0)
{
	
	string time1( MainSimulator::Instance().getParameter( description(), "processingTime" ) ) ;

	if( time1 != "" )
		processingTime = time1 ;

}

/*******************************************************************
* Function Name: externalFunction
* Description: the PermissionVerifier receives connectDevice, granted
********************************************************************/
Model &PermissionVerifier::externalFunction( const ExternalMessage &msg )
{
  if ( this->state() == passive)
  {
  
    if (msg.port() == connectDevice)
     {
       reqConnection = 1;  //set it to True
       accessOK = 0;         //set it to False
       holdIn(active, processingTime);
     }
    if (msg.port() == granted )
     {
       accessOK = 1;          //set it to True
       reqConnection = 0;  //set it to False
       holdIn(active, processingTime);
     }
     
	
  }
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &PermissionVerifier::internalFunction( const InternalMessage & )
{
	passivate();
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &PermissionVerifier::outputFunction( const InternalMessage &msg )
{

      if ( reqConnection == 1 )
        {
         sendOutput( msg.time(),reqPermission, 1);
        }
         
        else
        {
         sendOutput( msg.time(),connected,1);
        }
      
	return *this;
}


