/*******************************************************************
*
*  DESCRIPTION: Atomic Model PermissionVerifier
*
*  AUTHOR: Shafagh Jafer
*
*  EMAIL: sjafer@connect.carleton.ca
*
*
*  DATE: 8/06/2006
*
*******************************************************************/
#ifndef __PermissionVerifier_H
#define __PermissionVerifier_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class PermissionVerifier: public Atomic
{
public:
	PermissionVerifier( const string &name = "PermissionVerifier" ) ;	 // Default constructor

	

	virtual string className() const
		{return "PermissionVerifier";}

protected:
	Model &initFunction()
		{   accessOK = reqConnection  = 0;
			
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &connectDevice;
    const Port &granted ;
    Port &connected;
    Port &reqPermission ;
    Time processingTime;
    int   accessOK, reqConnection;
	

    
};	// class PermissionVerifier


#endif    //__PermissionVerifier_H
