/*******************************************************************
*
*  DESCRIPTION: Atomic Model ReceiverMobile
*
*  AUTHOR: Shafagh Jafer
*
*  EMAIL: sjafer@connect.carleton.ca
*
*
*  DATE: 8/06/2006
*
*******************************************************************/
#ifndef __RECEIVERMOBILE_H
#define __RECEIVERMOBILE_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class ReceiverMobile: public Atomic
{
public:
	ReceiverMobile( const string &name = "ReceiverMobile" ) ;	 // Default constructor

	

	virtual string className() const
		{return "ReceiverMobile";}

protected:
	Model &initFunction()
		{   totalMsgs = ID_requested = permission_given = gotMsg = 0;
                      ID = 123;
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &IDrequested;
    const Port &permit ;
    const Port &data ;
	Port &IDout;
    Port &accepted;
    Port &gotData;
    Port &newMsgArrival;
    Time permissionTime;
    Time transferTime;
    int   ID, totalMsgs, ID_requested, permission_given, gotMsg;
	

    
};	// class ReceiverMobile


#endif    //__RECEIVERMOBILE_H
