/*******************************************************************
*
*  DESCRIPTION: Atomic Model SenderMobile
*
*  AUTHOR: Shafagh Jafer
*
*  EMAIL: sjafer@connect.carleton.ca
*
*
*  DATE: 8/06/2006
*
*******************************************************************/
#ifndef __SENDERMOBILE_H
#define __SENDERMOBILE_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class SenderMobile: public Atomic
{
public:
	SenderMobile( const string &name = "SenderMobile" ) ;	 // Default constructor

	

	virtual string className() const
		{return "SenderMobile";}

protected:
	Model &initFunction()
		{   gotID = receiverID = enable = sending = 0;
			data = 555;
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &enableBT;
    const Port &deviceFound ;
    const Port &start ;
    const Port &dataSent;
    Port &searchDevice ;
    Port &connect ;
    Port &dataOut;
    Time permissionTime;
    Time transferTime;
    Time processingTime;
    int   gotID, receiverID,enable, sending, data;
	

    
};	// class SenderMobile


#endif    //__SENDERMOBILE_H
